There are five types of fill data:
Auto: The auto fill type.
Direction: The direction fill type.
Linear: The linear fill type.
Growth: The growth fill type.
Date: The date fill type.
SpreadJS provides methods to perform the fill.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div class="options-container">
<p>
Use the "Start Range" field to select a range to start the fill, "Whole Range" to select the entire range to
fill, and the "Fill Methods" and "Fill Series" fields to change how the fill happens.
</p>
<p>
Try selecting Sheet1!A1 as the start range and Sheet1!A1:C2 as the whole range, keep fillAuto as the fill method
and column as fill series. Then click the "fillAuto" button and see the sheet fill those cells.
</p>
<div class="option-row">
<label>Start Range</label>
<div id="startRange" spellcheck="false"
style="display:inline-block;border: 1px solid #808080;width:134px;vertical-align: middle;">
</div>
</div>
<div class="option-row">
<label>Whole Range</label>
<div id="wholeRange" spellcheck="false"
style="display:inline-block;border: 1px solid #808080;width:134px;vertical-align: middle;">
</div>
</div>
<div class="option-row">
<label>Fill Methods</label>
<select id="fillMethods" @change="fillMethodChangedHandle" v-model.number="fillMethods">
<option value='0' selected>fillAuto</option>
<option value='1'>fillAutobyDirection</option>
<option value='2'>fillLinear</option>
<option value='3'>fillGrowth</option>
<option value='4'>fillDate</option>
</select>
</div>
<div class="option-row">
<div id="fillSeriesSet" v-show="fillSeriesSet">
<label>FillSeries</label>
<select id="fillSeries" v-model.number="fillSeries">
<option value='0'>Column</option>
<option value='1'>Row</option>
</select>
</div>
<div id="fillDirectionSet" v-show="fillDirectionSet">
<label>FillDirection</label>
<select id="fillDirection" v-model.number="fillDirection">
<option value='0'>Left</option>
<option value='1'>Right</option>
<option value='2'>Up</option>
<option value='3'>Down</option>
</select>
</div>
</div>
<div class="option-row" id="fillDateUnitSet" v-show="fillDateUnitSet">
<label>FillDateUnit</label>
<select id="fillDateUnit" v-model.number="fillDateUnit">
<option value='0'>Day</option>
<option value='1'>Weekday</option>
<option value='2'>Month</option>
<option value='3'>Year</option>
</select>
</div>
<div class="option-row" id="fillStepAndStop" v-show="fillStepAndStop">
<label>Step</label>
<input type="text" id="step" v-model.number="step" />
<label>Stop</label>
<input type="text" id="stop" v-model.number="stop" />
</div>
<div class="option-row">
<label></label>
<input type="button" id="btnFillAuto" value="fillAuto" v-show="btnFillAuto" @click="btnFillAutoHandler" />
<input type="button" id="btnFillAutobyDirection" value="fillAutobyDirection" v-show="btnFillAutobyDirection"
@click="btnFillAutobyDirectionHandler" />
<input type="button" id="btnFillLinear" value="fillLinear" v-show="btnFillLinear"
@click="btnFillLinearHandler" />
<input type="button" id="btnFillGrowth" value="fillGrowth" v-show="btnFillGrowth"
@click="btnFillGrowthHandler" />
<input type="button" id="btnFillDate" value="fillDate" v-show="btnFillDate" @click="btnFillDateHandler" />
</div>
</div>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue'
import { ref } from "vue";
import GC from "@mescius/spread-sheets";
const spreadRef = ref(null);
const startRangeFormulaTextBox = ref(null);
const wholeRangeFormulaTextBox = ref(null);
const fillDirectionSet = ref(false);
const fillDateUnitSet = ref(false);
const fillStepAndStop = ref(false);
const btnFillAutobyDirection = ref(false);
const btnFillLinear = ref(false);
const btnFillGrowth = ref(false);
const btnFillDate = ref(false);
const fillSeriesSet = ref(true);
const fillMethods = ref(0);
const fillSeries = ref(0);
const fillDirection = ref(0);
const fillDateUnit = ref(0);
const step = ref("");
const stop = ref("");
const btnFillAuto = ref(true);
const getRange = (sheet, rangeString) => {
try {
let rangeObject = GC.Spread.Sheets.CalcEngine.formulaToExpression(sheet, rangeString).getRange(0, 0);
let range = new GC.Spread.Sheets.Range(rangeObject.row, rangeObject.col, rangeObject.rowCount, rangeObject.colCount);
return range;
} catch (e) {
throw new Error("Select Ranges are not right");
}
}
function fillMethodChangedHandle() {
switch (fillMethods.value) {
case 0:
fillSeriesSet.value = true;
btnFillAuto.value = true;
fillDateUnitSet.value = false;
fillDirectionSet.value = false;
btnFillAutobyDirection.value = false;
btnFillLinear.value = false;
btnFillGrowth.value = false;
btnFillDate.value = false;
fillStepAndStop.value = false;
break;
case 1:
fillDirectionSet.value = true;
btnFillAutobyDirection.value = true;
fillDateUnitSet.value = false;
fillSeriesSet.value = false;
btnFillAuto.value = false;
btnFillLinear.value = false;
btnFillGrowth.value = false;
btnFillDate.value = false;
fillStepAndStop.value = false;
break;
case 2:
fillSeriesSet.value = true;
btnFillLinear.value = true;
fillStepAndStop.value = true;
fillDateUnitSet.value = false;
fillDirectionSet.value = false;
btnFillAuto.value = false;
btnFillAutobyDirection.value = false;
btnFillGrowth.value = false;
btnFillDate.value = false;
break;
case 3:
fillSeriesSet.value = true;
btnFillGrowth.value = true;
fillStepAndStop.value = true;
fillDateUnitSet.value = false;
fillDirectionSet.value = false;
btnFillAuto.value = false;
btnFillAutobyDirection.value = false;
btnFillLinear.value = false;
btnFillDate.value = false;
break;
case 4:
fillSeriesSet.value = true;
btnFillDate.value = true;
fillStepAndStop.value = true;
fillDateUnitSet.value = true;
fillDirectionSet.value = false;
btnFillAuto.value = false;
btnFillAutobyDirection.value = false;
btnFillGrowth.value = false;
btnFillLinear.value = false;
break;
}
}
function initSpread(spread) {
spreadRef.value = spread;
let _startRangeFormulaTextBox = new GC.Spread.Sheets.FormulaTextBox.FormulaTextBox(document.getElementById('startRange'), {
rangeSelectMode: true
});
let _wholeRangeFormulaTextBox = new GC.Spread.Sheets.FormulaTextBox.FormulaTextBox(document.getElementById('wholeRange'), {
rangeSelectMode: true
});
_startRangeFormulaTextBox.workbook(spread);
_wholeRangeFormulaTextBox.workbook(spread);
startRangeFormulaTextBox.value = _startRangeFormulaTextBox;
wholeRangeFormulaTextBox.value = _wholeRangeFormulaTextBox;
spread.options.newTabVisible = false;
let sheet = spread.getSheet(0);
sheet.setValue(0, 0, 1);
}
function btnFillAutoHandler() {
let sheet = spreadRef.value.getActiveSheet();
let startRange = getRange(sheet, startRangeFormulaTextBox.value.text());
let wholeRange = getRange(sheet, wholeRangeFormulaTextBox.value.text());
if (fillSeries.value === 1) {
wholeRange.rowCount = startRange.rowCount;
} else {
wholeRange.colCount = startRange.colCount;
}
sheet.fillAuto(startRange, wholeRange, {
series: fillSeries.value,
fillType: GC.Spread.Sheets.Fill.FillType.auto
});
}
function btnFillAutobyDirectionHandler() {
let sheet = spreadRef.value.getActiveSheet();
let startRange = getRange(sheet, startRangeFormulaTextBox.value.text());
let wholeRange = getRange(sheet, wholeRangeFormulaTextBox.value.text());
sheet.fillAuto(startRange, wholeRange, {
direction: fillDirection.value,
fillType: GC.Spread.Sheets.Fill.FillType.direction
});
}
function btnFillLinearHandler() {
let sheet = spreadRef.value.getActiveSheet();
let startRange = getRange(sheet, startRangeFormulaTextBox.value.text());
let wholeRange = getRange(sheet, wholeRangeFormulaTextBox.value.text());
let _stop;
if (stop.value !== "") {
_stop = parseInt(stop.value);
}
sheet.fillAuto(startRange, wholeRange, {
series: fillSeries.value,
step: step.value,
stop: _stop,
fillType: GC.Spread.Sheets.Fill.FillType.linear
});
}
function btnFillGrowthHandler() {
let sheet = spreadRef.value.getActiveSheet();
let startRange = getRange(sheet, startRangeFormulaTextBox.value.text());
let wholeRange = getRange(sheet, wholeRangeFormulaTextBox.value.text());
let _stop;
if (stop.value !== "") {
_stop = parseInt(stop.value);
}
sheet.fillAuto(startRange, wholeRange, {
series: fillSeries.value,
step: step.value,
stop: _stop,
fillType: GC.Spread.Sheets.Fill.FillType.growth
});
}
function btnFillDateHandler() {
let sheet = spreadRef.value.getActiveSheet();
let startRange = getRange(sheet, startRangeFormulaTextBox.value.text());
let wholeRange = getRange(sheet, wholeRangeFormulaTextBox.value.text());
let _stop;
if (stop.value !== "") {
_stop = parseInt(stop.value);
}
sheet.fillAuto(startRange, wholeRange, {
series: fillSeries.value,
unit: fillDateUnit.value,
step: step.value,
stop: _stop,
fillType: GC.Spread.Sheets.Fill.FillType.date
});
}
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input,
select {
padding: 4px 8px;
}
input {
width: 100%;
margin-top: 6px;
box-sizing: border-box;
}
label {
display: inline-block;
min-width: 85px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.2.2-master-2026-09-02-2133/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-io': 'cdn:@mescius/spread-sheets-io/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js',
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

There are five types of fill data:
Auto: The auto fill type.
Direction: The direction fill type.
Linear: The linear fill type.
Growth: The growth fill type.
Date: The date fill type.
SpreadJS provides methods to perform the fill.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
fillDirectionSet = false;
fillDateUnitSet = false;
fillStepAndStop = false;
btnFillAutobyDirection = false;
btnFillLinear = false;
btnFillGrowth = false;
btnFillDate = false;
fillSeriesSet = true;
btnFillAuto = true;
fillMethods = 0;
fillSeries = 0;
fillDirection = 0;
fillDateUnit = 0;
step = "";
stop = "";
startRangeFormulaTextBox: GC.Spread.Sheets.FormulaTextBox.FormulaTextBox;
wholeRangeFormulaTextBox: GC.Spread.Sheets.FormulaTextBox.FormulaTextBox;
hostStyle = {
width: '100%',
height: '100%',
overflow: 'hidden',
float: 'left'
};
fillMethodChangedHandle($event: any) {
this.fillMethods = parseInt($event.target.value, 10);
switch (this.fillMethods) {
case 0:
this.fillSeriesSet = true;
this.btnFillAuto = true;
this.fillDateUnitSet = false;
this.fillDirectionSet = false;
this.btnFillAutobyDirection = false;
this.btnFillLinear = false;
this.btnFillGrowth = false;
this.btnFillDate = false;
this.fillStepAndStop = false;
break;
case 1:
this.fillDirectionSet = true;
this.btnFillAutobyDirection = true;
this.fillDateUnitSet = false;
this.fillSeriesSet = false;
this.btnFillAuto = false;
this.btnFillLinear = false;
this.btnFillGrowth = false;
this.btnFillDate = false;
this.fillStepAndStop = false;
break;
case 2:
this.fillSeriesSet = true;
this.btnFillLinear = true;
this.fillStepAndStop = true;
this.fillDateUnitSet = false;
this.fillDirectionSet = false;
this.btnFillAuto = false;
this.btnFillAutobyDirection = false;
this.btnFillGrowth = false;
this.btnFillDate = false;
break;
case 3:
this.fillSeriesSet = true;
this.btnFillGrowth = true;
this.fillStepAndStop = true;
this.fillDateUnitSet = false;
this.fillDirectionSet = false;
this.btnFillAuto = false;
this.btnFillAutobyDirection = false;
this.btnFillLinear = false;
this.btnFillDate = false;
break;
case 4:
this.fillSeriesSet = true;
this.btnFillDate = true;
this.fillStepAndStop = true;
this.fillDateUnitSet = true;
this.fillDirectionSet = false;
this.btnFillAuto = false;
this.btnFillAutobyDirection = false;
this.btnFillGrowth = false;
this.btnFillLinear = false;
break;
}
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
let startRangeFormulaTextBox = new GC.Spread.Sheets.FormulaTextBox.FormulaTextBox(document.getElementById('startRange'), {
rangeSelectMode: true
});
let wholeRangeFormulaTextBox = new GC.Spread.Sheets.FormulaTextBox.FormulaTextBox(document.getElementById('wholeRange'), {
rangeSelectMode: true
});
startRangeFormulaTextBox.workbook(spread);
wholeRangeFormulaTextBox.workbook(spread);
this.startRangeFormulaTextBox = startRangeFormulaTextBox;
this.wholeRangeFormulaTextBox = wholeRangeFormulaTextBox;
spread.options.newTabVisible = false;
let sheet = spread.getSheet(0);
sheet.setValue(0, 0, 1);
}
btnFillAutoHandler() {
var sheet = this.spread.getActiveSheet();
var startRange = getRange(sheet, this.startRangeFormulaTextBox.text());
var wholeRange = getRange(sheet, this.wholeRangeFormulaTextBox.text());
if (parseInt(this.fillSeries) === 1) {
wholeRange.rowCount = startRange.rowCount;
} else {
wholeRange.colCount = startRange.colCount;
}
sheet.fillAuto(startRange, wholeRange, {
series: parseInt(this.fillSeries),
fillType: GC.Spread.Sheets.Fill.FillType.auto
});
}
btnFillAutobyDirectionHandler() {
var sheet = this.spread.getActiveSheet();
var startRange = getRange(sheet, this.startRangeFormulaTextBox.text());
var wholeRange = getRange(sheet, this.wholeRangeFormulaTextBox.text());
sheet.fillAuto(startRange, wholeRange, {
direction: parseInt(this.fillDirection),
fillType: GC.Spread.Sheets.Fill.FillType.direction
});
}
btnFillLinearHandler() {
var sheet = this.spread.getActiveSheet();
var startRange = getRange(sheet, this.startRangeFormulaTextBox.text());
var wholeRange = getRange(sheet, this.wholeRangeFormulaTextBox.text());
var stop;
if(this.stop!==""){
stop = parseInt(this.stop);
}
var options={
series: parseInt(this.fillSeries),
step: parseInt(this.step),
stop: stop,
fillType: GC.Spread.Sheets.Fill.FillType.linear
};
sheet.fillAuto(startRange, wholeRange,options);
}
btnFillGrowthHandler() {
var sheet = this.spread.getActiveSheet();
var startRange = getRange(sheet, this.startRangeFormulaTextBox.text());
var wholeRange = getRange(sheet, this.wholeRangeFormulaTextBox.text());
var stop;
if(this.stop!==""){
stop=parseInt(this.stop);
}
var options={
series: parseInt(this.fillSeries),
step: parseInt(this.step),
stop: stop,
fillType: GC.Spread.Sheets.Fill.FillType.growth
};
sheet.fillAuto(startRange, wholeRange,options );
}
btnFillDateHandler() {
var sheet = this.spread.getActiveSheet();
var startRange = getRange(sheet, this.startRangeFormulaTextBox.text());
var wholeRange = getRange(sheet, this.wholeRangeFormulaTextBox.text());
var stop;
if(this.stop!==""){
stop=parseInt(this.stop);
}
var options= {
series: parseInt(this.fillSeries),
unit: parseInt(this.fillDateUnit),
step: parseInt(this.step),
stop: stop,
fillType: GC.Spread.Sheets.Fill.FillType.date
}
sheet.fillAuto(startRange, wholeRange,options);
}
}
const getRange = (sheet: GC.Spread.Sheets.Worksheet, rangeString: string) => {
try {
var rangeObject = GC.Spread.Sheets.CalcEngine.formulaToExpression(sheet, rangeString).getRange(0, 0);
var range = new GC.Spread.Sheets.Range(rangeObject.row, rangeObject.col, rangeObject.rowCount, rangeObject.colCount);
return range;
} catch (e) {
throw new Error("Select Ranges are not right");
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<script src="$DEMOROOT$/spread/source/data/ellipsis.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<p>
Use the "Start Range" field to select a range to start the fill, "Whole Range" to select the entire range to fill, and the "Fill Methods" and "Fill Series" fields to change how the fill happens.
</p>
<p>
Try selecting Sheet1!A1 as the start range and Sheet1!A1:C2 as the whole range, keep fillAuto as the fill method and column as fill series. Then click the "fillAuto" button and see the sheet fill those cells.
</p>
<div class="option-row">
<label>Start Range</label>
<div id="startRange" spellcheck="false" style="display:inline-block;border: 1px solid #808080;width:134px;vertical-align: middle;">
</div>
</div>
<div class="option-row">
<label>Whole Range</label>
<div id="wholeRange" spellcheck="false" style="display:inline-block;border: 1px solid #808080;width:134px;vertical-align: middle;">
</div>
</div>
<div class="option-row">
<label>Fill Methods</label>
<select id="fillMethods" (change)="fillMethodChangedHandle($event)" [value]="fillMethods|number" >
<option value='0' >fillAuto</option>
<option value='1'>fillAutobyDirection</option>
<option value='2'>fillLinear</option>
<option value='3'>fillGrowth</option>
<option value='4'>fillDate</option>
</select>
</div>
<div class="option-row">
<div id="fillSeriesSet" *ngIf="fillSeriesSet">
<label>FillSeries</label>
<select id="fillSeries" [(ngModel)] = "fillSeries" [value] = "fillSeries|number">
<option value=0>Column</option>
<option value=1>Row</option>
</select>
</div>
<div id="fillDirectionSet" *ngIf="fillDirectionSet">
<label>FillDirection</label>
<select id="fillDirection" [(ngModel)]="fillDirection" [value]="fillDirection|number">
<option value='0'>Left</option>
<option value='1'>Right</option>
<option value='2'>Up</option>
<option value='3'>Down</option>
</select>
</div>
</div>
<div class="option-row" id="fillDateUnitSet" *ngIf="fillDateUnitSet">
<label>FillDateUnit</label>
<select id="fillDateUnit" [(ngModel)]="fillDateUnit" [value] = "fillDateUnit|number">
<option value='0'>Day</option>
<option value='1'>Weekday</option>
<option value='2'>Month</option>
<option value='3'>Year</option>
</select>
</div>
<div class="option-row" id="fillStepAndStop" *ngIf="fillStepAndStop">
<label>Step</label>
<input type="text" id="step"[(ngModel)]="step" [value] = "step|number" />
<label>Stop</label>
<input type="text" id="stop" [(ngModel)]="stop" [value] = "stop|number" />
</div>
<div class="option-row">
<label></label>
<input type="button" id="btnFillAuto" value="fillAuto" *ngIf="btnFillAuto" (click)="btnFillAutoHandler()" />
<input type="button" id="btnFillAutobyDirection" value="fillAutobyDirection" *ngIf="btnFillAutobyDirection" (click)="btnFillAutobyDirectionHandler()" />
<input type="button" id="btnFillLinear" value="fillLinear" *ngIf="btnFillLinear" (click)="btnFillLinearHandler()" />
<input type="button" id="btnFillGrowth" value="fillGrowth" *ngIf="btnFillGrowth" (click)="btnFillGrowthHandler()" />
<input type="button" id="btnFillDate" value="fillDate" *ngIf="btnFillDate" (click)="btnFillDateHandler()" />
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input, select {
padding: 4px 8px;
}
input {
width: 100%;
margin-top: 6px;
box-sizing: border-box;
}
label {
display: inline-block;
min-width: 85px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.2.2-master-2026-09-02-2133/'
},
// map tells the System loader where to look for things
map: {
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

There are five types of fill data:
Auto: The auto fill type.
Direction: The direction fill type.
Linear: The linear fill type.
Growth: The growth fill type.
Date: The date fill type.
SpreadJS provides methods to perform the fill.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
const getRange = (sheet, rangeString) => {
try {
var rangeObject = GC.Spread.Sheets.CalcEngine.formulaToExpression(sheet, rangeString).getRange(0, 0);
var range = new GC.Spread.Sheets.Range(rangeObject.row, rangeObject.col, rangeObject.rowCount, rangeObject.colCount);
return range;
} catch (e) {
throw new Error("Select Ranges are not right");
}
}
let spread = null;
let startRangeFormulaTextBox;
let wholeRangeFormulaTextBox;
export function AppFunc() {
const [customFillOption, setCustomFillOption] = React.useState({
fillDirectionSet: false,
fillDateUnitSet: false,
fillStepAndStop: false,
btnFillAutobyDirection: false,
btnFillLinear: false,
btnFillGrowth: false,
btnFillDate: false,
fillSeriesSet: true,
fillMethods: 0,
fillSeries: 0,
fillDirection: 0,
fillDateUnit: 0,
step: "",
stop: "",
btnFillAuto: true
});
const stepChange = (event) => {
setCustomFillOption({...customFillOption, step:event.target.value});
}
const stopChange = (event) => {
setCustomFillOption({...customFillOption, stop:event.target.value});
}
const fillDirectionChangedHandle = (value) => {
setCustomFillOption({...customFillOption, fillDirection: value});
}
const fillSeriesChangedHandle = (value) => {
setCustomFillOption({...customFillOption, fillSeries: value});
}
const fillDateUnitChangedHandle = (value) => {
setCustomFillOption({...customFillOption, fillDateUnit: value});
}
const fillMethodChangedHandle = (value) => {
switch (value) {
case 0:
setCustomFillOption({
fillMethods: value,
fillSeriesSet: true,
btnFillAuto: true,
fillDateUnitSet: false,
fillDirectionSet: false,
btnFillAutobyDirection: false,
btnFillLinear: false,
btnFillGrowth: false,
btnFillDate: false,
fillStepAndStop: false,
});
break;
case 1:
setCustomFillOption({
...customFillOption,
fillMethods: value,
fillDirectionSet: true,
btnFillAutobyDirection: true,
fillDateUnitSet: false,
fillSeriesSet: false,
btnFillAuto: false,
btnFillLinear: false,
btnFillGrowth: false,
btnFillDate: false,
fillStepAndStop: false,
});
break;
case 2:
setCustomFillOption({
...customFillOption,
fillMethods: value,
fillSeriesSet: true,
btnFillLinear: true,
fillStepAndStop: true,
fillDateUnitSet: false,
fillDirectionSet: false,
btnFillAuto: false,
btnFillAutobyDirection: false,
btnFillGrowth: false,
btnFillDate: false,
})
break;
case 3:
setCustomFillOption({
...customFillOption,
fillMethods: value,
fillSeriesSet: true,
btnFillGrowth: true,
fillStepAndStop: true,
fillDateUnitSet: false,
fillDirectionSet: false,
btnFillAuto: false,
btnFillAutobyDirection: false,
btnFillLinear: false,
btnFillDate: false,
});
break;
case 4:
setCustomFillOption({
...customFillOption,
fillMethods: value,
fillSeriesSet: true,
btnFillDate: true,
fillStepAndStop: true,
fillDateUnitSet: true,
fillDirectionSet: false,
btnFillAuto: false,
btnFillAutobyDirection: false,
btnFillGrowth: false,
btnFillLinear: false,
});
break;
}
}
const initSpread = (currSpread) => {
spread = currSpread;
startRangeFormulaTextBox = new GC.Spread.Sheets.FormulaTextBox.FormulaTextBox(document.getElementById('startRange'), {
rangeSelectMode: true
});
wholeRangeFormulaTextBox = new GC.Spread.Sheets.FormulaTextBox.FormulaTextBox(document.getElementById('wholeRange'), {
rangeSelectMode: true
});
startRangeFormulaTextBox.workbook(spread);
wholeRangeFormulaTextBox.workbook(spread);
spread.options.newTabVisible = false;
let sheet = spread.getSheet(0);
sheet.setValue(0, 0, 1);
}
const btnFillAutoHandler = () => {
var sheet = spread.getActiveSheet();
var startRange = getRange(sheet, startRangeFormulaTextBox.text());
var wholeRange = getRange(sheet, wholeRangeFormulaTextBox.text());
if (customFillOption.fillSeries === 1) {
wholeRange.rowCount = startRange.rowCount;
} else {
wholeRange.colCount = startRange.colCount;
}
sheet.fillAuto(startRange, wholeRange, {
series: customFillOption.fillSeries,
fillType: GC.Spread.Sheets.Fill.FillType.auto
});
}
const btnFillAutobyDirectionHandler = () => {
var sheet = spread.getActiveSheet();
var startRange = getRange(sheet, startRangeFormulaTextBox.text());
var wholeRange = getRange(sheet, wholeRangeFormulaTextBox.text());
sheet.fillAuto(startRange, wholeRange, {
direction: customFillOption.fillDirection,
fillType: GC.Spread.Sheets.Fill.FillType.direction
});
}
const btnFillLinearHandler = () => {
var sheet = spread.getActiveSheet();
var startRange = getRange(sheet, startRangeFormulaTextBox.text());
var wholeRange = getRange(sheet, wholeRangeFormulaTextBox.text());
var stop;
if(customFillOption.stop!==""){
stop=customFillOption.stop;
stop=parseInt(stop);
}
var step=parseInt(customFillOption.step);
sheet.fillAuto(startRange, wholeRange, {
series: customFillOption.fillSeries,
step: step,
stop: stop,
fillType: GC.Spread.Sheets.Fill.FillType.linear
});
}
const btnFillGrowthHandler = () => {
var sheet = spread.getActiveSheet();
var startRange = getRange(sheet, startRangeFormulaTextBox.text());
var wholeRange = getRange(sheet, wholeRangeFormulaTextBox.text());
var stop;
if(customFillOption.stop!==""){
stop=customFillOption.stop;
stop=parseInt(stop);
}
var step=parseInt(customFillOption.step);
sheet.fillAuto(startRange, wholeRange, {
series: fillSeries,
step: step,
stop: stop,
fillType: GC.Spread.Sheets.Fill.FillType.growth
});
}
const btnFillDateHandler = () => {
var sheet = spread.getActiveSheet();
var startRange = getRange(sheet, startRangeFormulaTextBox.text());
var wholeRange = getRange(sheet, wholeRangeFormulaTextBox.text());
var stop;
if(customFillOption.stop!==""){
stop=customFillOption.stop;
stop=parseInt(stop);
}
var step=parseInt(customFillOption.step);
sheet.fillAuto(startRange, wholeRange, {
series: customFillOption.fillSeries,
unit: customFillOption.fillDateUnit,
step: step,
stop: stop,
fillType: GC.Spread.Sheets.Fill.FillType.date
});
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={initSpread}>
</SpreadSheets>
</div>
<Panel
panelInfo={customFillOption}
btnFillAutoHandler={btnFillAutoHandler}
btnFillAutobyDirectionHandler={btnFillAutobyDirectionHandler}
btnFillLinearHandler={btnFillLinearHandler}
btnFillGrowthHandler={btnFillGrowthHandler}
btnFillDateHandler={btnFillDateHandler}
fillMethodChangedHandle={fillMethodChangedHandle}
fillDirectionChangedHandle = {fillDirectionChangedHandle}
fillSeriesChangedHandle = {fillSeriesChangedHandle}
fillDateUnitChangedHandle = {fillDateUnitChangedHandle}
stepChange={stepChange}
stopChange={stopChange}
></Panel>
</div>
);
}
const Panel = (props) => {
const {
stepChange,
stopChange,
btnFillAutoHandler,
btnFillAutobyDirectionHandler,
btnFillLinearHandler,
btnFillGrowthHandler,
btnFillDateHandler,
fillMethodChangedHandle,
fillDirectionChangedHandle,
fillSeriesChangedHandle,
fillDateUnitChangedHandle,
} = props;
const [panelInfo, setPanelInfo] = React.useState(props.panelInfo);
React.useEffect(() => {
if (panelInfo !== props.panelInfo) {
setPanelInfo(props.panelInfo);
}
}, [props.panelInfo]);
return (
<div class="options-container">
<p>
Use the "Start Range" field to select a range to start the fill, "Whole Range" to select the entire range to fill, and the "Fill Methods" and "Fill Series" fields to change how the fill happens.
</p>
<p>
Try selecting Sheet1!A1 as the start range and Sheet1!A1:C2 as the whole range, keep fillAuto as the fill method and column as fill series. Then click the "fillAuto" button and see the sheet fill those cells.
</p>
<div class="option-row">
<label>Start Range</label>
<div id="startRange" spellcheck="false" style={{ display: "inline-block", border: '1px solid #808080', width: '134px', 'vertical-align': 'middle' }}>
</div>
</div>
<div class="option-row">
<label>Whole Range</label>
<div id="wholeRange" spellcheck="false" style={{ display: 'inline-block', border: '1px solid #808080', width: '134px', 'vertical-align': 'middle' }}>
</div>
</div>
<div class="option-row">
<label>Fill Methods</label>
<select id="fillMethods" onChange={(event) => { fillMethodChangedHandle(parseInt(event.target.value, 10)) }} value={panelInfo.fillMethods}>
<option value={0} selected>fillAuto</option>
<option value={1}>fillAutobyDirection</option>
<option value={2}>fillLinear</option>
<option value={3}>fillGrowth</option>
<option value={4}>fillDate</option>
</select>
</div>
<div class="option-row">
{panelInfo.fillSeriesSet && <div id="fillSeriesSet">
<label>FillSeries</label>
<select id="fillSeries" value={panelInfo.fillSeries} onChange = {(event) => {fillSeriesChangedHandle(parseInt(event.target.value, 10))}}>
<option value='0'>Column</option>
<option value='1'>Row</option>
</select>
</div>}
{panelInfo.fillDirectionSet && <div id="fillDirectionSet" >
<label>FillDirection</label>
<select id="fillDirection" value={panelInfo.fillDirection} onChange = {(event)=> {fillDirectionChangedHandle(parseInt(event.target.value, 10))}}>
<option value={0}>Left</option>
<option value={1}>Right</option>
<option value={2}>Up</option>
<option value={3}>Down</option>
</select>
</div >}
</div >
{panelInfo.fillDateUnitSet && <div class="option-row" id="fillDateUnitSet" >
<label>FillDateUnit</label>
<select id="fillDateUnit" value={panelInfo.fillDateUnit} onChange = {(event) => fillDateUnitChangedHandle(parseInt(event.target.value, 10))}>
<option value={0}>Day</option>
<option value={1}>Weekday</option>
<option value={2}>Month</option>
<option value={3}>Year</option>
</select>
</div >}
{panelInfo.fillStepAndStop && <div class="option-row" id="fillStepAndStop" >
<label>Step</label>
<input type="text" id="step" value={panelInfo.step} onChange={stepChange} />
<label>Stop</label>
<input type="text" id="stop" value={panelInfo.stop} onChange={stopChange} />
</div>}
<div class="option-row">
<label></label>
{panelInfo.btnFillAuto &&<input type="button" id="btnFillAuto" value="fillAuto" onClick={() => {btnFillAutoHandler()}} />}
{panelInfo.btnFillAutobyDirection && <input type="button" id="btnFillAutobyDirection" value="fillAutobyDirection" onClick={(event) => { btnFillAutobyDirectionHandler(event.target.value) }} />}
{panelInfo.btnFillLinear && <input type="button" id="btnFillLinear" value="fillLinear" onClick={(event) => { btnFillLinearHandler(event.target.value) }} />}
{panelInfo.btnFillGrowth && <input type="button" id="btnFillGrowth" value="fillGrowth" onClick={(event) => { btnFillGrowthHandler(event.target.value) }} />}
{panelInfo.btnFillDate && <input type="button" id="btnFillDate" value="fillDate" onClick={(event) => { btnFillDateHandler(event.target.value) }} />}
</div>
</div >
)
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
const Component = React.Component;
const getRange = (sheet, rangeString) => {
try {
var rangeObject = GC.Spread.Sheets.CalcEngine.formulaToExpression(sheet, rangeString).getRange(0, 0);
var range = new GC.Spread.Sheets.Range(rangeObject.row, rangeObject.col, rangeObject.rowCount, rangeObject.colCount);
return range;
} catch (e) {
throw new Error("Select Ranges are not right");
}
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
fillDirectionSet: false,
fillDateUnitSet: false,
fillStepAndStop: false,
btnFillAutobyDirection: false,
btnFillLinear: false,
btnFillGrowth: false,
btnFillDate: false,
fillSeriesSet: true,
fillMethods: 0,
fillSeries: 0,
fillDirection: 0,
fillDateUnit: 0,
step: "",
stop: "",
btnFillAuto: true
};
this.stopChange=this.stopChange.bind(this);
this.stepChange=this.stepChange.bind(this);
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<Panel
fillDirectionSet={this.state.fillDirectionSet}
fillDateUnitSet={this.state.fillDateUnitSet}
fillStepAndStop={this.state.fillStepAndStop}
btnFillAutobyDirection={this.state.btnFillAutobyDirection}
btnFillLinear={this.state.btnFillLinear}
btnFillGrowth={this.state.btnFillGrowth}
btnFillDate={this.state.btnFillDate}
fillSeriesSet={this.state.fillSeriesSet}
fillMethods={this.state.fillMethods}
fillSeries={this.state.fillSeries}
fillDirection={this.state.fillDirection}
fillDateUnit={this.state.fillDateUnit}
step={this.state.step}
stop={this.state.stop}
btnFillAuto={this.state.btnFillAuto}
btnFillAutoHandler={() => { this.btnFillAutoHandler() }}
btnFillAutobyDirectionHandler={() => { this.btnFillAutobyDirectionHandler() }}
btnFillLinearHandler={() => { this.btnFillLinearHandler() }}
btnFillGrowthHandler={() => { this.btnFillGrowthHandler() }}
btnFillDateHandler={() => { this.btnFillDateHandler() }}
fillMethodChangedHandle={(value) => { this.fillMethodChangedHandle(value) }}
fillDirectionChangedHandle = {(value) => {this.fillDirectionChangedHandle(value)}}
fillSeriesChangedHandle = {(value) =>{this.fillSeriesChangedHandle(value)}}
fillDateUnitChangedHandle = {(value) => {this.fillDateUnitChangedHandle(value)}}
stepChange={(event)=>{this.stepChange(event)}}
stopChange={(event)=>{this.stopChange(event)}}
></Panel>
</div>
)
}
stepChange(event){
this.setState({step:event.target.value});
}
stopChange(event){
this.setState({stop:event.target.value});
}
fillDirectionChangedHandle(value){
this.setState({fillDirection: value});
}
fillSeriesChangedHandle(value){
this.setState({fillSeries: value});
}
fillDateUnitChangedHandle(value){
this.setState({fillDateUnit: value});
}
fillMethodChangedHandle(value) {
this.setState({ fillMethods: value });
switch (value) {
case 0:
this.setState({
fillSeriesSet: true,
btnFillAuto: true,
fillDateUnitSet: false,
fillDirectionSet: false,
btnFillAutobyDirection: false,
btnFillLinear: false,
btnFillGrowth: false,
btnFillDate: false,
fillStepAndStop: false,
});
break;
case 1:
this.setState({
fillDirectionSet: true,
btnFillAutobyDirection: true,
fillDateUnitSet: false,
fillSeriesSet: false,
btnFillAuto: false,
btnFillLinear: false,
btnFillGrowth: false,
btnFillDate: false,
fillStepAndStop: false,
});
break;
case 2:
this.setState({
fillSeriesSet: true,
btnFillLinear: true,
fillStepAndStop: true,
fillDateUnitSet: false,
fillDirectionSet: false,
btnFillAuto: false,
btnFillAutobyDirection: false,
btnFillGrowth: false,
btnFillDate: false,
})
break;
case 3:
this.setState({
fillSeriesSet: true,
btnFillGrowth: true,
fillStepAndStop: true,
fillDateUnitSet: false,
fillDirectionSet: false,
btnFillAuto: false,
btnFillAutobyDirection: false,
btnFillLinear: false,
btnFillDate: false,
});
break;
case 4:
this.setState({
fillSeriesSet: true,
btnFillDate: true,
fillStepAndStop: true,
fillDateUnitSet: true,
fillDirectionSet: false,
btnFillAuto: false,
btnFillAutobyDirection: false,
btnFillGrowth: false,
btnFillLinear: false,
});
break;
}
}
initSpread(spread) {
this.spread = spread;
let startRangeFormulaTextBox = new GC.Spread.Sheets.FormulaTextBox.FormulaTextBox(document.getElementById('startRange'), {
rangeSelectMode: true
});
let wholeRangeFormulaTextBox = new GC.Spread.Sheets.FormulaTextBox.FormulaTextBox(document.getElementById('wholeRange'), {
rangeSelectMode: true
});
startRangeFormulaTextBox.workbook(spread);
wholeRangeFormulaTextBox.workbook(spread);
this.startRangeFormulaTextBox = startRangeFormulaTextBox;
this.wholeRangeFormulaTextBox = wholeRangeFormulaTextBox;
spread.options.newTabVisible = false;
let sheet = spread.getSheet(0);
sheet.setValue(0, 0, 1);
}
btnFillAutoHandler() {
var sheet = this.spread.getActiveSheet();
var startRange = getRange(sheet, this.startRangeFormulaTextBox.text());
var wholeRange = getRange(sheet, this.wholeRangeFormulaTextBox.text());
if (this.state.fillSeries === 1) {
wholeRange.rowCount = startRange.rowCount;
} else {
wholeRange.colCount = startRange.colCount;
}
sheet.fillAuto(startRange, wholeRange, {
series: this.state.fillSeries,
fillType: GC.Spread.Sheets.Fill.FillType.auto
});
}
btnFillAutobyDirectionHandler() {
var sheet = this.spread.getActiveSheet();
var startRange = getRange(sheet, this.startRangeFormulaTextBox.text());
var wholeRange = getRange(sheet, this.wholeRangeFormulaTextBox.text());
sheet.fillAuto(startRange, wholeRange, {
direction: this.state.fillDirection,
fillType: GC.Spread.Sheets.Fill.FillType.direction
});
}
btnFillLinearHandler() {
var sheet = this.spread.getActiveSheet();
var startRange = getRange(sheet, this.startRangeFormulaTextBox.text());
var wholeRange = getRange(sheet, this.wholeRangeFormulaTextBox.text());
var stop;
if(this.state.stop!==""){
stop=this.state.stop;
stop=parseInt(stop);
}
var step=parseInt(this.state.step);
sheet.fillAuto(startRange, wholeRange, {
series: this.state.fillSeries,
step: step,
stop: stop,
fillType: GC.Spread.Sheets.Fill.FillType.linear
});
}
btnFillGrowthHandler() {
var sheet = this.spread.getActiveSheet();
var startRange = getRange(sheet, this.startRangeFormulaTextBox.text());
var wholeRange = getRange(sheet, this.wholeRangeFormulaTextBox.text());
var stop;
if(this.state.stop!==""){
stop=this.state.stop;
stop=parseInt(stop);
}
var step=parseInt(this.state.step);
sheet.fillAuto(startRange, wholeRange, {
series: this.fillSeries,
step: step,
stop: stop,
fillType: GC.Spread.Sheets.Fill.FillType.growth
});
}
btnFillDateHandler() {
var sheet = this.spread.getActiveSheet();
var startRange = getRange(sheet, this.startRangeFormulaTextBox.text());
var wholeRange = getRange(sheet, this.wholeRangeFormulaTextBox.text());
var stop;
if(this.state.stop!==""){
stop=this.state.stop;
stop=parseInt(stop);
}
var step=parseInt(this.state.step);
sheet.fillAuto(startRange, wholeRange, {
series: this.state.fillSeries,
unit: this.state.fillDateUnit,
step: step,
stop: stop,
fillType: GC.Spread.Sheets.Fill.FillType.date
});
}
}
const Panel = (props) => {
const {
fillDirectionSet,
fillDateUnitSet,
fillStepAndStop,
btnFillAuto,
btnFillAutobyDirection,
btnFillLinear,
btnFillGrowth,
btnFillDate,
fillSeriesSet,
fillMethods,
fillSeries,
fillDirection,
fillDateUnit,
step,
stop,
btnFillAutoHandler,
btnFillAutobyDirectionHandler,
btnFillLinearHandler,
btnFillGrowthHandler,
btnFillDateHandler,
fillMethodChangedHandle,
fillDirectionChangedHandle,
fillSeriesChangedHandle,
fillDateUnitChangedHandle,
} = props;
return (
<div class="options-container">
<p>
Use the "Start Range" field to select a range to start the fill, "Whole Range" to select the entire range to fill, and the "Fill Methods" and "Fill Series" fields to change how the fill happens.
</p>
<p>
Try selecting Sheet1!A1 as the start range and Sheet1!A1:C2 as the whole range, keep fillAuto as the fill method and column as fill series. Then click the "fillAuto" button and see the sheet fill those cells.
</p>
<div class="option-row">
<label>Start Range</label>
<div id="startRange" spellcheck="false" style={{ display: "inline-block", border: '1px solid #808080', width: '134px', 'vertical-align': 'middle' }}>
</div>
</div>
<div class="option-row">
<label>Whole Range</label>
<div id="wholeRange" spellcheck="false" style={{ display: 'inline-block', border: '1px solid #808080', width: '134px', 'vertical-align': 'middle' }}>
</div>
</div>
<div class="option-row">
<label>Fill Methods</label>
<select id="fillMethods" onChange={(event) => { fillMethodChangedHandle(parseInt(event.target.value, 10)) }} value={fillMethods}>
<option value={0} selected>fillAuto</option>
<option value={1}>fillAutobyDirection</option>
<option value={2}>fillLinear</option>
<option value={3}>fillGrowth</option>
<option value={4}>fillDate</option>
</select>
</div>
<div class="option-row">
{fillSeriesSet && <div id="fillSeriesSet">
<label>FillSeries</label>
<select id="fillSeries" value={fillSeries} onChange = {(event) => {fillSeriesChangedHandle(parseInt(event.target.value, 10))}}>
<option value='0'>Column</option>
<option value='1'>Row</option>
</select>
</div>}
{fillDirectionSet && <div id="fillDirectionSet" >
<label>FillDirection</label>
<select id="fillDirection" value={fillDirection} onChange = {(event)=> {fillDirectionChangedHandle(parseInt(event.target.value, 10))}}>
<option value={0}>Left</option>
<option value={1}>Right</option>
<option value={2}>Up</option>
<option value={3}>Down</option>
</select>
</div >}
</div >
{fillDateUnitSet && <div class="option-row" id="fillDateUnitSet" >
<label>FillDateUnit</label>
<select id="fillDateUnit" value={fillDateUnit} onChange = {(event) => fillDateUnitChangedHandle(parseInt(event.target.value, 10))}>
<option value={0}>Day</option>
<option value={1}>Weekday</option>
<option value={2}>Month</option>
<option value={3}>Year</option>
</select>
</div >}
{fillStepAndStop && <div class="option-row" id="fillStepAndStop" >
<label>Step</label>
<input type="text" id="step" value={step} onChange={props.stepChange}/>
<label>Stop</label>
<input type="text" id="stop" value={stop} onChange={props.stopChange} />
</div>}
<div class="option-row">
<label></label>
{btnFillAuto &&<input type="button" id="btnFillAuto" value="fillAuto" onClick={() => {btnFillAutoHandler()}} />}
{btnFillAutobyDirection && <input type="button" id="btnFillAutobyDirection" value="fillAutobyDirection" onClick={(event) => { btnFillAutobyDirectionHandler(event.target.value) }} />}
{btnFillLinear && <input type="button" id="btnFillLinear" value="fillLinear" onClick={(event) => { btnFillLinearHandler(event.target.value) }} />}
{btnFillGrowth && <input type="button" id="btnFillGrowth" value="fillGrowth" onClick={(event) => { btnFillGrowthHandler(event.target.value) }} />}
{btnFillDate && <input type="button" id="btnFillDate" value="fillDate" onClick={(event) => { btnFillDateHandler(event.target.value) }} />}
</div>
</div >
)
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="$DEMOROOT$/spread/source/data/ellipsis.js" type="text/javascript"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input, select {
padding: 4px 8px;
}
input {
width: 100%;
margin-top: 6px;
box-sizing: border-box;
}
label {
display:inline-block;
min-width: 85px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.2.2-master-2026-09-02-2133/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);